<template>
  <table class="table">
    <thead>
      <tr>
        <th v-if="selectable" class="vtable-checkbox">
          <div class="btn-group" role="group">
            <button
              type="button"
              class="btn btn-primary dropdown-toggle"
              data-bs-toggle="dropdown"
              aria-haspopup="true"
              aria-expanded="false"
              :disabled="disabled"
            >
              Select...
            </button>
            <div class="dropdown-menu">
              <a class="dropdown-item" href="#" @click="onClickSelectAll">
                <i class="bi bi-check-square"></i>
                All
              </a>
              <a class="dropdown-item" href="#" @click="onClickSelectNone">
                <i class="bi bi-square"></i>
                None
              </a>
              <a class="dropdown-item" href="#" @click="onClickSelectInverse">
                <i class="bi bi-arrow-left-right"></i>
                Inverse
              </a>
            </div>
          </div>
        </th>
        <th v-for="(column, columnIndex) in columns" :key="columnIndex" :class="column.class" v-html="column.heading" />
      </tr>
      <tr v-for="(row, rowIndex) in modelValue" :key="rowIndex">
        <td v-if="selectable" class="text-center">
          <div class="form-check">
            <input
              class="form-check-input"
              type="checkbox"
              :checked="row[checkedPropertyName]"
              :disabled="disabled"
              @input="onCheckboxInput($event, rowIndex)"
            />
          </div>
        </td>
        <td v-for="(column, x) in columns" :key="x" :class="column.class" v-html="row[column.propertyName]" />
      </tr>
    </thead>
  </table>
</template>

<script>
export default {
  name: 'VTable',
  emits: ['update:modelValue'],
  props: {
    columns: { type: Array, required: true },
    modelValue: { type: Array, required: true },
    selectable: { type: Boolean, default: false },
    checkedPropertyName: { type: String, default: '' },
    disabled: { type: Boolean, default: false },
  },
  setup(props, context) {
    const onCheckboxInput = (event, rowIndex) => {
      const mutatedValue = [...props.modelValue]
      mutatedValue[rowIndex][props.checkedPropertyName] = event.target.checked
      context.emit('update:modelValue', mutatedValue)
    }

    const onClickSelectAll = () => {
      if (props.disabled) {
        return
      }
      const mutatedValue = [...props.modelValue]
      for (let rowIndex = 0; rowIndex < props.modelValue.length; rowIndex++) {
        mutatedValue[rowIndex][props.checkedPropertyName] = true
      }
      context.emit('update:modelValue', mutatedValue)
    }

    const onClickSelectNone = () => {
      if (props.disabled) {
        return
      }
      const mutatedValue = [...props.modelValue]
      for (let rowIndex = 0; rowIndex < props.modelValue.length; rowIndex++) {
        mutatedValue[rowIndex][props.checkedPropertyName] = false
      }
      context.emit('update:modelValue', mutatedValue)
    }

    const onClickSelectInverse = () => {
      if (props.disabled) {
        return
      }
      const mutatedValue = [...props.modelValue]
      for (let rowIndex = 0; rowIndex < props.modelValue.length; rowIndex++) {
        mutatedValue[rowIndex][props.checkedPropertyName] = !props.modelValue[rowIndex][props.checkedPropertyName]
      }
      context.emit('update:modelValue', mutatedValue)
    }

    return {
      onCheckboxInput,
      onClickSelectAll,
      onClickSelectNone,
      onClickSelectInverse,
    }
  },
}
</script>

<style lang="scss">
.vtable-checkbox {
  text-align: center;
  width: 1px;
}
</style>
